--- icewm-1.3.8/Makefile.in
+++ icewm-1.3.8/Makefile.in
@@ -35,7 +35,7 @@
 
 ################################################################################
 
-BINFILES    = @BINFILES@ icewm-set-gnomewm
+BINFILES    = @BINFILES@ "$(srcdir)/icewm-set-gnomewm"
 LIBFILES    = lib/preferences lib/winoptions lib/keys \
               lib/menu lib/toolbar # lib/programs
 DOCFILES    = README BUGS CHANGES COPYING AUTHORS INSTALL VERSION icewm.lsm
@@ -83,21 +83,23 @@
 	@echo ------------------------------------------
 	@echo "Installing binaries in $(DESTDIR)$(BINDIR)"
 	@$(INSTALLDIR) "$(DESTDIR)$(BINDIR)"
+#generated files, relative to the build directory
 	@for bin in $(BINFILES); do \
              $(INSTALLBIN) "$${bin}" "$(DESTDIR)$(BINDIR)"; \
          done
 	
 	@echo "Installing presets and icons in $(DESTDIR)$(LIBDIR)"
 	@$(INSTALLDIR) "$(DESTDIR)$(LIBDIR)"
+# data files from the source directory
 	#-@$(INSTALLDIR) "$(DESTDIR)$(CFGDIR)"
 	@for lib in $(LIBFILES); do \
-             $(INSTALLLIB) "$${lib}" "$(DESTDIR)$(LIBDIR)"; \
+             $(INSTALLLIB) "$(top_srcdir)/$${lib}" "$(DESTDIR)$(LIBDIR)"; \
          done
 
 	@for xpmdir in $(XPMDIRS); do \
-	     if test -d "lib/$${xpmdir}"; then \
+	     if test -d "$(top_srcdir)/lib/$${xpmdir}"; then \
 		$(INSTALLDIR) "$(DESTDIR)$(LIBDIR)/$${xpmdir}"; \
-		for pixmap in "lib/$${xpmdir}/"*.xpm; do \
+		for pixmap in "$(top_srcdir)/lib/$${xpmdir}/"*.xpm; do \
 		    $(INSTALLLIB) "$${pixmap}" "$(DESTDIR)$(LIBDIR)/$${xpmdir}"; \
 		done; \
 	    fi; \
--- icewm-1.3.8/po/Makefile.in
+++ icewm-1.3.8/po/Makefile.in
@@ -20,6 +20,7 @@
 XGETTEXT =	@XGETTEXT@
 MSGMERGE =	@MSGMERGE@
 MSGFMT =	@MSGFMT@
+VPATH = .:po:@srcdir@
 
 .SUFFIXES:
 .SUFFIXES: .po .mo
--- icewm-1.3.8/src/Makefile.in
+++ icewm-1.3.8/src/Makefile.in
@@ -11,7 +11,7 @@
 
 CXX =           @CXX@
 HOSTCXX =       @HOSTCXX@
-LD =            @CXX_LINK@
+LD =            gcc
 HOSTLD =        @HOSTCXX_LINK@
 EXEEXT =        @EXEEXT@
 
@@ -32,12 +32,12 @@
                 -DICEWMBGEXE='"icewmbg$(EXEEXT)"' \
                 -DICESMEXE='"icewm-session$(EXEEXT)"' \
                 -DICEHELPEXE='"icehelp$(EXEEXT)"' \
-                -DICEHELPIDX='"$(DOCDIR)/icewm-$(VERSION)/icewm.html"'
+                -DICEHELPIDX='"$(DOCDIR)/icewm-common/icewm.html"'
 
 CXXFLAGS =      @CXXFLAGS@ $(DEBUG) $(DEFS) `pkg-config gdk-pixbuf-xlib-2.0 --cflags` \
 	        @CORE_CFLAGS@ @IMAGE_CFLAGS@ @AUDIO_CFLAGS@ `pkg-config fontconfig --cflags`
 LFLAGS =	@LDFLAGS@ 
-LIBS =          @LIBS@ `pkg-config gdk-pixbuf-xlib-2.0 --libs` 
+LIBS =          @LIBS@ `pkg-config gdk-pixbuf-xlib-2.0 --libs` -lfontconfig -lm -lsupc++
 
 CORE_LIBS =     @CORE_LIBS@ `pkg-config fontconfig --libs`
 IMAGE_LIBS =    @IMAGE_LIBS@
@@ -188,6 +188,8 @@
 TESTCASES = @TESTCASES@
 OBJECTS = @BASEOBJS@ @TESTOBJS@
 BINARIES = @BASEBINS@ @TESTBINS@
+BASEOBJS = @BASEOBJS@
+VPATH = .:@srcdir@
 
 ################################################################################
 
@@ -205,7 +207,8 @@
 	@echo "  CXX     " $@
 	@$(CXX) $(CXXFLAGS) $(GCCDEP) -c $<
 
-$(BINARIES):
+$(BINARIES): $(BASEOBJS)
+#	@$(MAKE) --no-print-directory build-dep DEPLIST="$($(@:$(EXEEXT)=)_OBJS)"
 	@echo "  LD      " $@
 	@$(LD) -o $@ $($(@:$(EXEEXT)=)_OBJS) $(LFLAGS) $($(@:$(EXEEXT)=)_LFLAGS) $(LIBS) $($(@:$(EXEEXT)=)_LIBS)
 
@@ -217,6 +220,8 @@
 	@echo "  HOSTLD  " $@
 	@$(HOSTLD) -o $@ $(genpref_OBJS)
 
+build-dep: $(DEPLIST)
+
 ################################################################################
 
 gnome2.o: gnome2.cc
--- icewm-1.3.8/src/WinMgr.h
+++ icewm-1.3.8/src/WinMgr.h
@@ -128,7 +128,7 @@
  * this where WIN_WORKSPACE_COUNT comes into play.
  */
 
-#define WinWorkspaceInvalid    (-1L)
+#define WinWorkspaceInvalid    ((unsigned long)-1)
 
 /* workspaces */
 #define XA_WIN_WORKSPACES "_WIN_WORKSPACES"
